Summary:	GNU Compiler Collection
Name:		gcc
Version:	4.1.2
Release:	2
License:	GPL
Group:		Libraries
URL:            http://gcc.gnu.org/
Source0:	%{name}-%{version}.tar.bz2
Patch0:		%{name}-%{version}.diff
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)
%define		_sysconfdir	/etc

%description
A compiler aimed at integrating all the optimizations and features
necessary for a high-performance and stable development environment.
Example: "c, ada, c++, fortran, java, objc, obj-c++, treelang".

cvs -d:pserver:ext:anoncvs@savannah.gnu.org:/cvsroot/gcc co gcc

%package 	devel
Summary:	GCC headers & static libraries
Group:		Development

%description 	devel
Headers for "c, ada, c++, fortran, java, objc, obj-c++, treelang" develop.

%package	infoman
Summary:	Information and manual pages.
Group:		Development

%description	infoman
The Documentation for "c, ada, c++, fortran, java, objc, obj-c++, treelang".

%prep
%setup -q -n %{name}-%{version}
%patch0 -p0

%build
rm -rf obj-%{_target_platform} && install -d obj-%{_target_platform} && cd obj-%{_target_platform}

CFLAGS="$CFLAGS" \
CXXFLAGS="$CXXFLAGS" \
TEXCONFIG=false ../configure \
	--prefix=%{_prefix} \
	--infodir=%{_infodir} \
	--mandir=%{_mandir} \
	--enable-shared \
	--disable-static \
	--with-system-zlib \
	--enable-threads=posix \
	--enable-haifa \
	--enable-languages="c,c++,fortran,java,objc,obj-c++,treelang" \
	--enable-long-long \
	--enable-namespaces \
	--enable-multilib \
	--with-gnu-as \
	--with-gnu-ld \
	--with-system-zlib \
	--without-x \
	--disable-werror \
	--disable-checking \
	--enable-__cxa_atexit \
	--disable-nls \
	--without-included-gettext \
	%{_target_platform}

PATH=$PATH:/sbin:%{_sbindir}

cd ..
%{__make} -C obj-%{_target_platform} bootstrap-lean \
	LDFLAGS_FOR_TARGET="-s" \
	mandir=%{_mandir} \
	infodir=%{_infodir}

cd obj-%{_target_platform} && make -C gcc CC="./xgcc -B ./ -Os -march=i386 -mtune=i386 -fomit-frame-pointer -w -s" proto

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/lib,%{_datadir}}

cd obj-%{_target_platform}
PATH=$PATH:/sbin:%{_sbindir}

%{__make} install \
	prefix=$RPM_BUILD_ROOT%{_prefix} \
	mandir=$RPM_BUILD_ROOT%{_mandir} \
	infodir=$RPM_BUILD_ROOT%{_infodir}

chmod 755 $RPM_BUILD_ROOT/usr/lib/*so*
cd $RPM_BUILD_ROOT/lib; ln -sf ../usr/bin/cpp .
cd $RPM_BUILD_ROOT/usr/share/java; ln -sf libgcj*.jar libgcj.jar
cd $RPM_BUILD_ROOT/usr/lib/gcc/i386-pc-linux/%{version}/include; ln -sf /usr/X11R6/include/X11 .
strip -g $RPM_BUILD_ROOT/usr/lib/*.a; rm $RPM_BUILD_ROOT/usr/lib/libiberty.a
# Uncomment next line for GCC--3.4x-3.5x
cp -r $RPM_BUILD_ROOT/usr/libexec/gcc/i386-pc-linux/%{version}/* $RPM_BUILD_ROOT/usr/lib/gcc/i386-pc-linux/%{version}; cd $RPM_BUILD_ROOT/usr/libexec; rm -rf gcc; ln -sf ../lib/gcc .

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
/usr/lib/*.so.*
/usr/lib/*.so
/usr/lib/*.la
/usr/lib/classpath
/usr/lib/security
/usr/bin/cpp
/lib

%files devel
/usr/lib/*.a
/usr/lib/*.spec
/usr/lib/logging.properties
/usr/libexec
/usr/lib/gcc
/usr/lib/gcj*
/usr/lib/pkgconfig
/usr/bin/a*
/usr/bin/c++
/usr/bin/f*
/usr/bin/g*
/usr/bin/i*
/usr/bin/j*
/usr/bin/p*
/usr/bin/u*
/usr/include
/usr/share

%files infoman
%defattr(-, root, root)
/usr/info
/usr/man
